#include <SoftwareSerial.h>
SoftwareSerial SIM800(5, 6);       // Передача между SIM800L и мк  (RX, TX)
SoftwareSerial input(9, 8);        // Передача между контроллерами (RX, TX)
#define quantity 4
// OLED
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4

Adafruit_SSD1306 display(OLED_RESET);
// OLED
long tm;
float Mass[quantity];
bool check = false, // приход данных с мк
     mic = false,   // есть данные с микрофона
     esc = false,   // есть данные со всего улья в целом
     mass = false,  // есть данные с датчиков веса
     Sim800Err = false; // данные об ошибке sim800
int i = 1;
// сообщения
String OutputMessage = "",
       _response = "",
       phone = "",
       InputMessege = "",
       number = "+79635441385";
// сообщения
void setup() {
  Serial.begin(9600);              // Скорость обмена данными с компьютером
  Serial.println("Start! GeneralControllerFull1.0");
  WindowSetup();
  SIM800.begin(9600);              // Скорость обмена данными с модемом
  SIM800.listen();
  sendATCommand("AT", true);
  sendATCommand("AT+CMGF=1", true);// Включить TextMode для SMS
  sendATCommand("AT+DDET=1,0,1", true);// Включить DTMF
  sendATCommand("AT+CLIP=1", true);// Включить АОН  
  input.begin(9600);               // Скорость обмена данными с контроллерами
  for (int i = 0; i < quantity; i++) Mass[i] = 0;
  while (millis() < 5000) {};
  display.clearDisplay();
  display.display();
  //sendSMS(phone, InfoMessageOutput());
}
void loop() {
  display.clearDisplay();
  Window1();
  //display.clearDisplay();
  CheckBeeVoid();
  SIM800_Loop();
  if (Serial.available())  {                    // Ожидаем команды по Serial...
    SIM800.write(Serial.read());                // ...и отправляем полученную команду модему
  }
}
void CheckBeeVoid() { //  общая функция проверки всех ульев поочередно
  if (millis() - tm > 5000) {
    input.listen(); //  включаем актвность порта
    checkAllBee(); 
    tm = millis();
  }
}
bool chechbool() { // фуекция приема данных с локального контроллера
  int  m = input.parseInt();
  //Serial.print(m);
  if (m == 1) {
    return false;
  }
  if (m == 2) {
    return true;
  }
}
void checkOneBee() {                      // проверка каждого отдельного улья
  if (check) {                            // если контроллер готов к принятию команды...
    Serial.println("Отправка команды");
    input.write('i');                     // отправляем команду
    float x = input.parseFloat();         // принимаем вес
    if (x != 0) {
      Mass[i] = x;                        // заносим в реестр
    }


    //char readInput = input.read();
    //микрофон
    if (input.available()) {          // Ожидаем прихода данных (ответа) от контроллера...
      //микрофон
      mic = chechbool();              // принимаем данные о микрофоне
      //вес
      mass = chechbool();             // принимаем данные о резком изменении веса
      //улей
      esc = chechbool();              // принимаем данные о вылете пчел (если оба выше сработали
    }
    ErrorMessege();

    //--- вывод в порт
//    Serial.print(i); Serial.print(": ");
//    Serial.print(Mass[i]); Serial.print(' ');
//    if (!mic)  Serial.write('O');
//    else Serial.write('E');
//    //вес
//    if (!mass)  Serial.write('O');
//    else Serial.write('E');
//    //улей
//    if (!esc)  Serial.write('O');
//    else Serial.write('E');
//    check = false;
//    Serial.println();
    //--- вывод в порт
  }
}
void checkAllBee() { // проверка всех ульев по очередно 
  for (i = 1; i <= quantity; i++) { // включаем счетчик 
    //input.print('R');
    input.print(i);                 // отправляем id контролера
    Serial.print(i);
    bool cheked = false;            // булева о принятии данных с контроллера
    float TimeWhileRead = millis(); // время, в течении которого ожидается принятие данных с контроллера.
    while (millis() - TimeWhileRead < 250 ) { // цикл временной
      if (input.available()) {                // если данные все так и пришли...
        char readInput = input.read();        // принимаем символ от контроллера
        //Serial.println(readInput);
        if (readInput == 'O') {               // если символ равен 'O'...
          cheked  = true;                     // изменяем булевы о том, что контроллер ответил
          check = true;
          Serial.println("Контроллер ответил!");
          checkOneBee();                      // принимаем данные с данного контроллера
        }
      } //else Serial.println("non");**/
    }
    if (!cheked) {                            // если данные не пришли, то выводим  ошибку
      Serial.print("ERR"); Serial.println(i);
    }
    delay(100);                               // микро задержка, для более точной передачи данных
  }
  Serial.println();
}
void ErrorMessege(){  // функция для отправки смс при принятии данных с улья
  if (mic)  sendSMS(number, MicActive(i));
  if (mass) sendSMS(number, MassActive(i));
  if (esc)  sendSMS(number, BeeActive(i));
}
void SIM800_Loop() {  // фукция сим
  SIM800.listen();
  if (SIM800.available())   {                   // Если модем, что-то отправил...
    _response = waitResponse();                 // Получаем ответ от модема для анализа
    _response.trim();                           // Убираем лишние пробелы в начале и конце
    Serial.print("SIM800: "); Serial.println(_response);                  // Если нужно выводим в монитор порта
    //....
    InputSMS();
    if (InputMessege == "Info") {         // если смс инфо...
      sendSMS(phone, InfoMessageOutput());// отправляем информционное сообщение
      Serial.println("СООБЩЕНИЕ");        
      InputMessege = ""; 
    }
  }
}
void InputSMS() {     // функция приема смс
  if (_response.startsWith("+CMTI:")) {       // Пришло сообщение об отправке SMS
    int index = _response.lastIndexOf(",");   // Находим последнюю запятую, перед индексом
    String result = _response.substring(index + 1, _response.length()); // Получаем индекс
    result.trim();                            // Убираем пробельные символы в начале/конце
    _response = sendATCommand("AT+CMGR=" + result, true); // Получить содержимое SMS
    InputMessege = parseSMS(_response);
    Serial.println("Message: " + InputMessege); // Распарсить SMS на элементы
    Serial.println("Phone: " + phone);
    sendATCommand("AT+CMGDA=\"DEL ALL\"", true); // Удалить все сообщения, чтобы не забивали память модуля
  }
  //  AT+CPMS?
}
String InfoMessageOutput() {
  String StrInfo = "";
  for (int g = 1; g <= quantity; g++) {
    StrInfo +=  String(g) + ": " + floatToStr(Mass[g - 1]) + "; ";

    Serial.println(StrInfo);
  }


  return StrInfo;
}
String floatToStr(float floatVal) { // функция перевода флоат переменной в строку
  char charVal[10];               //temporarily holds data from vals
  String stringVal = "";     //data on buff is copied to this string
  dtostrf(floatVal, 4, 4, charVal);  //4 is mininum width, 4 is precision; float value is copied onto buff
  for (int i = 0; i < sizeof(charVal); i++)
  {
    stringVal += charVal[i];
  }
  return stringVal;
}
String MicActive(int numBee) {      
  return "ZVUK " + String(numBee);
}
String MassActive(int numBee) {
  return "VES ISMENILSA " + String(numBee);
}
String BeeActive(int numBee) {
  return "ROY " + String(numBee);
}
double TimeWindow = 0;
int maxCount = quantity,
    count = -1;
String utf8rus(String source){
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) {
    n = source[i]; i++;

    if (n >= 0xC0) {
      switch (n) {
        case 0xD0: {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
          break;
        }
        case 0xD1: {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB8; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
  return target;
}
void WindowSetup(){
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3D (for the 128x64)
  display.cp437(true);
  display.display();
}
void Window1(){
  counter();
  display.setTextColor(WHITE);
  if (count == 0)WindowSim800Err();
  display.display();
}
void WindowSim800Err(){
  display.setTextSize(3);
  display.setCursor(5,5);
  if (Sim800Err == true){
     display.println("Error Sim800L");
  }
}
void counter(){
  if (millis() - TimeWindow > 2000){
    if (count != maxCount) count ++;
    else count = 1;
    TimeWindow = millis();
  }
}
